// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.3.0
// - protoc             v3.12.4
// source: echoserver.proto

package proto

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

const (
	EchoApi_Echo_FullMethodName    = "/main.EchoApi/Echo"
	EchoApi_GetUser_FullMethodName = "/main.EchoApi/GetUser"
)

// EchoApiClient is the client API for EchoApi service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type EchoApiClient interface {
	Echo(ctx context.Context, in *ResponseRequest, opts ...grpc.CallOption) (*ResponseRequest, error)
	GetUser(ctx context.Context, in *UserRequest, opts ...grpc.CallOption) (*UserResponse, error)
}

type echoApiClient struct {
	cc grpc.ClientConnInterface
}

func NewEchoApiClient(cc grpc.ClientConnInterface) EchoApiClient {
	return &echoApiClient{cc}
}

func (c *echoApiClient) Echo(ctx context.Context, in *ResponseRequest, opts ...grpc.CallOption) (*ResponseRequest, error) {
	out := new(ResponseRequest)
	err := c.cc.Invoke(ctx, EchoApi_Echo_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *echoApiClient) GetUser(ctx context.Context, in *UserRequest, opts ...grpc.CallOption) (*UserResponse, error) {
	out := new(UserResponse)
	err := c.cc.Invoke(ctx, EchoApi_GetUser_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// EchoApiServer is the server API for EchoApi service.
// All implementations must embed UnimplementedEchoApiServer
// for forward compatibility
type EchoApiServer interface {
	Echo(context.Context, *ResponseRequest) (*ResponseRequest, error)
	GetUser(context.Context, *UserRequest) (*UserResponse, error)
	mustEmbedUnimplementedEchoApiServer()
}

// UnimplementedEchoApiServer must be embedded to have forward compatible implementations.
type UnimplementedEchoApiServer struct {
}

func (UnimplementedEchoApiServer) Echo(context.Context, *ResponseRequest) (*ResponseRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Echo not implemented")
}
func (UnimplementedEchoApiServer) GetUser(context.Context, *UserRequest) (*UserResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetUser not implemented")
}
func (UnimplementedEchoApiServer) mustEmbedUnimplementedEchoApiServer() {}

// UnsafeEchoApiServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to EchoApiServer will
// result in compilation errors.
type UnsafeEchoApiServer interface {
	mustEmbedUnimplementedEchoApiServer()
}

func RegisterEchoApiServer(s grpc.ServiceRegistrar, srv EchoApiServer) {
	s.RegisterService(&EchoApi_ServiceDesc, srv)
}

func _EchoApi_Echo_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ResponseRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(EchoApiServer).Echo(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: EchoApi_Echo_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(EchoApiServer).Echo(ctx, req.(*ResponseRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _EchoApi_GetUser_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UserRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(EchoApiServer).GetUser(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: EchoApi_GetUser_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(EchoApiServer).GetUser(ctx, req.(*UserRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// EchoApi_ServiceDesc is the grpc.ServiceDesc for EchoApi service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var EchoApi_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "main.EchoApi",
	HandlerType: (*EchoApiServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Echo",
			Handler:    _EchoApi_Echo_Handler,
		},
		{
			MethodName: "GetUser",
			Handler:    _EchoApi_GetUser_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "echoserver.proto",
}
